'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               zTrace 1.52                                |
'|                                                                          |
'|                      Win32 SDK debugging window DLL                      |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                         copyright(c) 2009-2009                           |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 04-04-2009 (MM-DD-YYYY)            |
'|                        Last revised : 05-07-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE DLL "zTrace.dll"

#INCLUDE "WIN32API.INC"

'----------------------------------------------------------------------

%dwStyle = %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN OR %WS_CAPTION OR %WS_SYSMENU OR %WS_THICKFRAME
%dwExStyle = %WS_EX_TOOLWINDOW

$ZTRACE              = "zTrace 1.52"

%HORIZONTAL_EXTENT   = 6000 '// Maximum value for the horizontal scrollbar
%MIN_WIDTH           = 300  '// default client width size
%MIN_HEIGHT          = 65   '// default client height size

%ID_LISTBOX          = 1

%IDM_About           = 101  '// menu popup
%IDM_Hscroll         = 103  '// menu popup
%IDM_Print           = 104  '// menu popup
%IDM_CopyToClipboard = 105  '// menu popup
%IDM_ClearContent    = 106  '// menu popup
%IDM_TopMost         = 107  '// menu popup
%IDM_Debug           = 108  '// menu popup
%IDM_SaveCoordinates = 109  '// menu popup

$Anti                = "\"
$zLim                = "|"
$RegistryKey         = "SOFTWARE\zTrace"
$RegistryCoordinates = "Coordinates"

GLOBAL gnX, gnY, gnW, gnH, gnBackBrush, gbUseTopMost, gbSaveCoordinates, gbDebug, gbScrollBar AS LONG

'----------------------------------------------------------------------

'// Returns a registry string
FUNCTION zGetReg (BYVAL hLocation AS DWORD, zSubKeys AS ASCIIZ, zValueName AS ASCIIZ) AS STRING
    LOCAL hKey AS DWORD, zRegVal AS ASCIIZ * %MAX_PATH, dwType AS DWORD, dwSize AS DWORD
    IF hLocation = 0 THEN hLocation = %HKEY_CURRENT_USER
    IF (RegOpenKeyEx(hLocation, TRIM$(zSubKeys, $Anti), 0, %KEY_READ, hKey) = 0) THEN
       dwType = %REG_SZ
     ' Set length of buffer...
       dwSize = SIZEOF(zRegVal)
       CALL RegQueryValueEx(hKey, zValueName, 0, dwType, zRegVal, dwSize)
       CALL RegCloseKey(hKey)
    END IF
    FUNCTION = zRegVal
END FUNCTION

'// Saves a string value to the registry, returns nonzero if successful
FUNCTION zSetReg (BYVAL hLocation AS DWORD, zSubKeys AS ASCIIZ, zRegName AS ASCIIZ, zRegVal AS ASCIIZ) AS LONG
    LOCAL hKey AS DWORD, dwType AS DWORD, dwSize AS DWORD, nRet AS LONG
    nRet = 0
    IF hLocation = 0 THEN hLocation = %HKEY_CURRENT_USER
    IF RegCreateKeyEx(hLocation, TRIM$(zSubKeys, $Anti), 0, "", 0, %KEY_WRITE, BYVAL %Null, hKey, BYVAL %Null) = 0 THEN
     ' Set length of data...
       dwSize = LEN(zRegVal)
       dwType = %REG_SZ
       IF RegSetValueEx(hKey, zRegName, 0, dwType, zRegVal, dwSize) = 0 THEN nRet = %True
       CALL RegCloseKey(hKey)
    END IF
    FUNCTION = nRet
END FUNCTION

SUB zLoadSaveCoordinates (BYREF x AS LONG, BYREF y AS LONG, BYREF w AS LONG, BYREF h AS LONG, BYVAL RW AS LONG)
    LOCAL zFileName AS ASCIIZ * %MAX_PATH, hFile AS LONG
    STATIC WasCoordinates AS STRING

    zFileName = zGetTempPath + "zTrace.cfg"
    IF RW THEN
       WasCoordinates = LTRIM$(STR$(x)) + "," + LTRIM$(STR$(y)) + "," + LTRIM$(STR$(w)) + "," + LTRIM$(STR$(h)) + "," + _
                        LTRIM$(STR$(gbUseTopMost)) + "," + _
                        LTRIM$(STR$(gbSaveCoordinates)) + "," + _
                        LTRIM$(STR$(gbScrollBar)) + "," + _
                        LTRIM$(STR$(gbDebug))
       IF LEN(WasCoordinates) THEN
          CALL zKillFile(zFileName)
          IF zFOpen(zFileName, 1, 1, hFile) = 0 THEN
             CALL zFPut(hFile, WasCoordinates)
             CALL zFClose(hFile)
          ELSE ' We should never go here, i keep it to remember how the settings were saved with version < 1.52
             CALL zSetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistryCoordinates, (WasCoordinates))
          END IF
       END IF
    ELSE
       IF LEN(WasCoordinates) = 0 THEN
          IF zExist(zFileName) THEN
             IF zFOpen(zFileName, 0, 0, hFile) = 0 THEN
                WasCoordinates = SPACE$(zFlof(hFile))
                CALL zFGet(hFile, WasCoordinates)
                CALL zFClose(hFile)
             END IF
          ELSE ' To retrieve the settings of version < 1.52
             WasCoordinates = zGetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistryCoordinates)
          END IF
          x = VAL(PARSE$(WasCoordinates, 1))
          y = VAL(PARSE$(WasCoordinates, 2))
          w = VAL(PARSE$(WasCoordinates, 3))
          h = VAL(PARSE$(WasCoordinates, 4))
          gbUseTopMost       = VAL(PARSE$(WasCoordinates, 5))
          gbSaveCoordinates  = VAL(PARSE$(WasCoordinates, 6)): IF gbSaveCoordinates = 0 THEN w = 0
          gbScrollBar        = VAL(PARSE$(WasCoordinates, 7))
          gbDebug            = VAL(PARSE$(WasCoordinates, 8))
       END IF
       IF w = 0 OR h = 0 THEN w = %MIN_WIDTH: h = %MIN_HEIGHT: x = 0: y = 0
    END IF
END SUB

FUNCTION zInstance () AS LONG
    FUNCTION = GetModuleHandle("")
END FUNCTION

FUNCTION zTrace ALIAS "zTrace" (zTmp AS ASCIIZ) EXPORT AS LONG
    LOCAL nRet AS LONG, hWnd AS DWORD, zPtr AS DWORD
    zPtr =  VARPTR(zTmp)
    hWnd = FindWindow($ZTRACE, $ZTRACE)
    IF hWnd = 0 THEN
       nRet = %LB_ERR
       LOCAL hThread AS DWORD
       THREAD CREATE ShowPopup(zPtr) TO hThread
       IF hThread THEN nRet = 0
       apiSLEEP(100)
    ELSE
       IF LEN(zTmp) THEN nRet = AddString(GetDlgItem(hWnd, %ID_LISTBOX), zPtr)
    END IF
    FUNCTION = nRet
END FUNCTION

FUNCTION DLLMAIN (BYVAL DllInstance AS LONG, BYVAL Reason AS LONG, BYVAL Reserved AS LONG) AS LONG

    LOCAL nRet AS LONG

    nRet = %TRUE

    IF Reason = %DLL_PROCESS_DETACH THEN
       IF gnBackBrush THEN
          CALL DeleteObject(gnBackBrush): gnBackBrush = 0
          CALL zLoadSaveCoordinates (gnX, gnY, gnW, gnH, 1)
       END IF
       CALL zDebug("")
    END IF

    FUNCTION = nRet

END FUNCTION

FUNCTION zGetTextListbox(BYVAL hListBox AS LONG, BYVAL nItem AS LONG) AS STRING
    LOCAL nLength AS LONG, sItem AS STRING
    nLength = SendMessage(hListBox, %LB_GETTEXTLEN, nItem, 0)
    sItem = SPACE$(nLength)
    nLength = SendMessage(hListBox, %LB_GETTEXT, nItem, BYVAL STRPTR(sItem))
    FUNCTION = sItem
END FUNCTION

FUNCTION ToolProc (BYVAL hWnd AS DWORD, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

    LOCAL rc, rw AS RECT, K, nCount, nSelItems, hCtrl AS LONG, sBuffer AS STRING

    SELECT CASE LONG Msg
    CASE %WM_CREATE
        'A good place to initiate things, declare variables,
        'create controls and read/set settings from a file, etc.
        '-------------------------------------------------------
         IF gnBackBrush = 0 THEN gnBackBrush = CreateSolidBrush(&H00FFFF)

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         CALL SetRect(rc, 0, 0, %MIN_WIDTH, %MIN_HEIGHT)
         CALL AdjustWindowRectEx(rc, %dwStyle, %FALSE, %dwExStyle)  ' Adjust Window To True Requested Size
         pMM = lParam
         @pMM.ptMinTrackSize.x = rc.nRight
         @pMM.ptMinTrackSize.y = rc.nBottom

    CASE %WM_COMMAND
        'Messages from controls and menu items are handled here.
        '-------------------------------------------------------
        SELECT CASE LOWRD(wParam)
        CASE %IDCANCEL
             IF HIWRD(wParam) = %BN_CLICKED THEN
                CALL SendMessage(hWnd, %WM_DESTROY, wParam, lParam)
                FUNCTION = 0 : EXIT FUNCTION
             END IF

        CASE %ID_LISTBOX

        CASE %IDM_About
             Message$ = "                Debugging window" + _
                        "||    Copyright  " + RIGHT$(DATE$, 4) + " Patrice TERRIER " + _
                        "|            pterrier@zapsolution.com" + _
                        "||               www.zapsolution.com"
             REPLACE $zLim WITH $CR IN Message$

             CALL MessageBox(0, (Message$), $ZTRACE, %MB_OK)

        CASE %IDM_Hscroll
             hCtrl = GetDlgItem(hWnd, %ID_LISTBOX)
             gbScrollBar = NOT gbScrollBar
             IF gbScrollBar THEN
                CALL ShowScrollBar(hCtrl, %SB_HORZ, %TRUE)
                CALL SendMessage(hCtrl, %LB_SETHORIZONTALEXTENT, %HORIZONTAL_EXTENT, 0)
             ELSE
                CALL SendMessage(hCtrl, %LB_SETHORIZONTALEXTENT, 1, 0)
                CALL ShowScrollBar(hCtrl, %SB_HORZ, %FALSE)
             END IF
             CALL UpdateWindow(hCtrl)

        CASE %IDM_Print
             hCtrl = GetDlgItem(hWnd, %ID_LISTBOX)
             nCount = SendMessage(hCtrl, %LB_GETCOUNT, 0, 0)
             IF nCount > 0 THEN
                XPRINT ATTACH DEFAULT
                IF LEN(XPRINT$) > 0 THEN
                   nSelItems = SendMessage(hCtrl, %LB_GETSELCOUNT, 0, 0)
                   IF nSelItems > 0 THEN
                      REDIM SelItem(1 TO nSelItems) AS LONG
                      nCount = SendMessage(hCtrl, %LB_GETSELITEMS, nSelItems&, VARPTR(SelItem&(1)))
                      FOR K = 1 TO nSelItems
                          XPRINT zGetTextListbox(hCtrl, SelItem(K))
                      NEXT
                   ELSE
                      FOR K = 0 TO nCount - 1
                          XPRINT zGetTextListbox(hCtrl, K)
                      NEXT
                   END IF
                   XPRINT FORMFEED           ' Issue a formfeed
                   XPRINT CLOSE              ' Deselect the printer
                END IF
             END IF

        CASE %IDM_CopyToClipboard
             hCtrl = GetDlgItem(hWnd, %ID_LISTBOX)
             nCount = SendMessage(hCtrl, %LB_GETCOUNT, 0, 0)
             IF nCount > 0 THEN
                sBuffer = ""

                nSelItems = SendMessage(hCtrl, %LB_GETSELCOUNT, 0, 0)
                IF nSelItems > 0 THEN
                   REDIM SelItem(1 TO nSelItems) AS LONG
                   nCount = SendMessage(hCtrl, %LB_GETSELITEMS, nSelItems&, VARPTR(SelItem&(1)))
                   FOR K = 1 TO nSelItems
                       sBuffer = sBuffer + zGetTextListbox(hCtrl, SelItem(K)) + $CRLF
                   NEXT
                ELSE
                   FOR K = 0 TO nCount - 1
                       sBuffer = sBuffer + zGetTextListbox(hCtrl, K) + $CRLF
                   NEXT
                END IF

'               CLIPBOARD SET TEXT sBuffer '// requires PB 9.0+
                LOCAL hClipData, hGlob AS DWORD
                hClipData = GlobalAlloc(%GMEM_MOVEABLE OR %GMEM_DDESHARE, LEN(sBuffer) + 1)
                hGlob = GlobalLock(hClipData)
                POKE$ hGlob, sBuffer + CHR$(0)
                CALL GlobalUnlock(hClipData)
                IF OpenClipboard(0) THEN
                   CALL EmptyClipboard()
                   CALL SetClipboardData(%CF_TEXT, hClipData)
                   CALL CloseClipboard()
                ELSE
                   CALL GlobalFree(hClipData)
                END IF

            END IF

        CASE %IDM_ClearContent
             CALL SendMessage(GetDlgItem(hWnd, %ID_LISTBOX), %LB_RESETCONTENT, 0, 0)

        CASE %IDM_TopMost
'             LOCAL UseStyle AS LONG
             gbUseTopMost = NOT gbUseTopMost
             IF gbUseTopMost THEN
                CALL SetWindowPos(hWnd, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE OR %SWP_SHOWWINDOW)
             ELSE
                CALL SetWindowPos(hWnd, %HWND_NOTOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE OR %SWP_SHOWWINDOW)
             END IF

        CASE %IDM_Debug
             gbDebug = NOT gbDebug
             IF gbDebug THEN
                hCtrl = GetDlgItem(hWnd, %ID_LISTBOX)
                nCount = SendMessage(hCtrl, %LB_GETCOUNT, 0, 0)
                IF nCount > 0 THEN
                   FOR K = 0 TO nCount - 1
                       CALL zDebug(zGetTextListbox(hCtrl, K))
                   NEXT
                END IF
             ELSE
                zDebug("") '// Close zDebug.txt if already open.
             END IF

        CASE %IDM_SaveCoordinates
             gbSaveCoordinates = NOT gbSaveCoordinates

        END SELECT

    CASE %WM_CTLCOLORDLG
         SetBkColor wParam, GetSysColor(%COLOR_WINDOW)
         FUNCTION = GetStockObject(%NULL_BRUSH)
         EXIT FUNCTION

    CASE %WM_CTLCOLORBTN, %WM_CTLCOLOREDIT, %WM_CTLCOLORLISTBOX, %WM_CTLCOLORSTATIC
         ' wParam is handle of control's display context (hDC)
         ' lParam is handle of control
         '------------------------------------------------------
         IF lParam = GetDlgItem(hWnd, %ID_LISTBOX) THEN
            CALL SetBkColor(wParam, &H00FFFF)
            FUNCTION = gnBackBrush
            EXIT FUNCTION
         END IF

    CASE %WM_RBUTTONDOWN
         LOCAL hMenu, nChoice AS LONG, p AS POINTAPI
         LOCAL menuStyle AS LONG
         hMenu = CreatePopupMenu()
         IF hMenu THEN
            CALL AppendMenu(hMenu, %MF_STRING, %IDM_About          , "About")
            CALL AppendMenu(hMenu, %MF_SEPARATOR, 102              , "")
            IF gbScrollBar THEN menuStyle = %MF_STRING OR %MF_CHECKED ELSE menuStyle = %MF_STRING
            CALL AppendMenu(hMenu, menuStyle,  %IDM_Hscroll        , "Use horizontal scrollbar")
            CALL AppendMenu(hMenu, %MF_STRING, %IDM_Print          , "Send selection to printer")
            CALL AppendMenu(hMenu, %MF_STRING, %IDM_CopyToClipboard, "Copy selection to clipboard")
            CALL AppendMenu(hMenu, %MF_STRING, %IDM_ClearContent   , "Clear content")
            IF gbUseTopMost THEN menuStyle = %MF_STRING OR %MF_CHECKED ELSE menuStyle = %MF_STRING
            CALL AppendMenu(hMenu, menuStyle,  %IDM_TopMost        , "Set window TopMost")
            IF gbDebug THEN menuStyle = %MF_STRING OR %MF_CHECKED ELSE menuStyle = %MF_STRING
            CALL AppendMenu(hMenu, menuStyle,  %IDM_Debug, "Create zDebug.txt report")
            IF gbSaveCoordinates THEN menuStyle = %MF_STRING OR %MF_CHECKED ELSE menuStyle = %MF_STRING
            CALL AppendMenu(hMenu, menuStyle,  %IDM_SaveCoordinates, "Save window coordinates")

            CALL GetCursorPos(p)
            nChoice = TrackPopupMenuEx(hMenu, %TPM_RETURNCMD, p.X, p.Y, hWnd, BYVAL %NULL)
            CALL DestroyMenu(hMenu)
            IF nChoice THEN CALL SendMessage(hWnd, %WM_COMMAND, MAKLNG(nChoice, 0), 0)
         END IF
         'EXIT FUNCTION

    CASE %WM_MOVE
         CALL GetWindowRect(hWnd, rw): gnX = rw.nLeft: gnY = rw.nTop

    CASE %WM_SIZE
         IF wParam <> %SIZE_MINIMIZED THEN
            gnW = LOWRD(lParam): gnH = HIWRD(lParam)
            CALL MoveWindow(GetDlgItem(hWnd, %ID_LISTBOX), 0, 0, gnW, gnH, %TRUE)
            CALL UpdateWindow(hWnd)

            CALL GetWindowRect(hWnd, rw): gnX = rw.nLeft: gnY = rw.nTop

         END IF

    CASE %WM_DESTROY
         IF gnBackBrush THEN
            CALL DeleteObject(gnBackBrush): gnBackBrush = 0
            CALL GetWindowRect(hWnd, rw)
            CALL GetClientRect(hWnd, rc)
            CALL zLoadSaveCoordinates (rw.nLeft, rw.nTop, rc.nRight, rc.nBottom, 1)
         END IF

         CALL PostQuitMessage(0)
         FUNCTION = 0 : EXIT FUNCTION

    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
END FUNCTION

FUNCTION zFlof(BYVAL hFile AS LONG) AS LONG
    LOCAL fSize AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       fSize = GetFileSize(hFile, BYVAL %NULL)
       IF fSize > -1& THEN FUNCTION = fSize
    END IF
END FUNCTION

FUNCTION zFPut (BYVAL hFile AS LONG, BYVAL sBuffer AS STRING) AS LONG
    LOCAL LenBuf, ByttesWritten AS LONG
    IF hFile THEN
       LenBuf = LEN(sBuffer)
       IF LenBuf THEN
          IF WriteFile(hFile, BYVAL STRPTR(sBuffer), LenBuf, ByttesWritten, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError()
          END IF
       END IF
    END IF
END FUNCTION

FUNCTION zFGet (BYVAL hFile AS LONG, BYREF sBuffer AS STRING) AS LONG
    LOCAL LenBuf, ByttesReaded AS LONG
    IF hFile THEN
       LenBuf = LEN(sBuffer)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(sBuffer), LenBuf, ByttesReaded, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError
          END IF
       END IF
    END IF
END FUNCTION

' Generic open file function
FUNCTION zFOpen (zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) AS LONG

    LOCAL AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFile(zFilName, AccessIs, ShareIs, BYVAL %NULL, %OPEN_ALWAYS, FlagAndAttribute, BYVAL %NULL)

    IF hFile = CLNG(%INVALID_HANDLE_VALUE) THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError               ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

' Check if disk file exist
FUNCTION zExist (zFileSpec AS ASCIIZ) AS LONG
    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
    IF LEN(zFileSpec) THEN
       hFind = FindFirstFile(zFileSpec, fd)
       IF hFind <> %INVALID_HANDLE_VALUE THEN
          CALL FindClose(hFind)
          FUNCTION = -1
       END IF
    END IF
END FUNCTION

' Get the system temp path
FUNCTION zGetTempPath () AS STRING
    LOCAL nSize AS LONG, sTempPath AS STRING
  ' If the returned GetTempPath directory does not exist the function creates it.
    sTempPath = SPACE$(GetTempPath(0, BYVAL %NULL))
    nSize = GetTempPath(LEN(sTempPath), BYVAL STRPTR(sTempPath))
    sTempPath = RTRIM$(sTempPath, ANY CHR$(0,92))
    FUNCTION = sTempPath + $Anti
END FUNCTION

' Returns current Disk and Path
SUB zDskPath(Dsk$, Path$)
'   Dsk$ and Path$ are ready to be concatened with a filename
'   Dsk$ and Paths correspond to the current directory
    LOCAL zTmp AS ASCIIZ * 260
    IF GetCurrentDirectory(BYVAL SIZEOF(zTmp), zTmp) THEN
       Dsk$ = LEFT$(zTmp, 2)
       Path$ = RTRIM$(MID$(zTmp, 3), ANY CHR$(0,92)) + $Anti
    END IF
END SUB

' Splits a full path name, and return the current disk and directory
SUB zSplitN (BYVAL sFullName$, sPathName$, sFilName$)
' If no path is specified then the current directory is being used.
    sPathName$ = "": sFilName$ = ""
    Length& = LEN(sFullName$)
    IF Length& THEN
       CALL zDskPath(Dsk$, ThisPath$): sFilName$ = sFullName$
       So& = INSTR(-1, sFullName$, $Anti)
       IF So& THEN
          sPathName$ = LEFT$(sFullName$, So&)
       ELSE
          So& = INSTR(sFullName$, ":")
       END IF
       IF sPathName$ = Dsk$ OR LEN(sPathName$) = 0 THEN
          sPathName$ = Dsk$ + ThisPath$
       END IF
       IF So& THEN sFilName$ = MID$(sFullName$, So& + 1, Length& - So&)
    END IF
END SUB

'// Kill directly a file without sending it to recycle.bin
FUNCTION zKillFile (zFullName AS ASCIIZ) AS LONG
    LOCAL zTmp AS ASCIIZ * %MAX_PATH, sPathName, sToKill AS STRING
    CALL zSplitN (zFullName, sPathName, sToKill)
    sToKill = DIR$(zFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
    DO WHILE LEN(sToKill)
       zTmp = sPathName + sToKill
       CALL SetFileAttributes(zTmp, %FILE_ATTRIBUTE_NORMAL)
       IF DeleteFile(zTmp) = 0 THEN FUNCTION = GetLastError: EXIT DO
       sToKill = DIR$
    LOOP
END FUNCTION

' Dito CLOSE
SUB zFClose (hFile AS LONG)
    IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END SUB

' Copy any debug string to a sequential ASCII file.
SUB zDebug ALIAS "zDebug" (zMessage AS ASCIIZ) STATIC EXPORT
    DIM hDebug AS LONG, NeverBeenThere AS LONG
    DIM zFileName AS ASCIIZ * 16
    IF hDebug AND LEN(zMessage) = 0 THEN
       CALL zFClose(hDebug)
       NeverBeenThere = 0
       EXIT SUB
    END IF
    IF LEN(zMessage) THEN
       IF NeverBeenThere = 0 THEN
          NeverBeenThere = -1
          zFileName = "zDebug.txt"
          CALL zKillFile(zFileName)
          CALL zFOpen(zFileName, 2, 4, hDebug)
       END IF
       CALL zFPut(hDebug, zMessage + $CRLF)
    END IF
END SUB

FUNCTION AddString(BYVAL hCtrl AS DWORD, BYVAL zPtr AS DWORD) AS LONG
    LOCAL nRet AS LONG
    IF gbDebug THEN
       IF zPtr THEN CALL zDebug(PEEK$(zPtr, 260))
    END IF
    nRet = SendMessage(hCtrl, %LB_ADDSTRING, 0, zPtr) '// VARPTR(zMessage))

    'CALL SendMessage(hCtrl, %LB_SETSEL, 1, nRet)   '//1.51
    'CALL SendMessage(hCtrl, %LB_SETSEL, 0, nRet)   '//1.51
    CALL SendMessage(hCtrl, %LB_SETTOPINDEX, nRet, 0)

    FUNCTION = nRet
END FUNCTION

THREAD FUNCTION ShowPopup (BYVAL zPtr AS DWORD) AS LONG

    LOCAL Msg                  AS tagMsg
    LOCAL IsInitialized        AS LONG
    LOCAL hWnd, hCtrl AS DWORD

    LOCAL wc AS WndClassEx, szClassName AS ASCIIZ * 80
    LOCAL rc, rw AS RECT

    szClassName = $ZTRACE

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zInstance(), szClassName, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(ToolProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0 '// %EXTEND_EXTRA * 4
       wc.hInstance     = zInstance()
       wc.hIcon         = 0
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = GetSysColorBrush(%COLOR_BTNFACE)
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(szClassName)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN
       LOCAL UseX, UseY, UseW, UseH AS LONG
       CALL zLoadSaveCoordinates (UseX, UseY, UseW, UseH, 0)

       CALL SetRect(rc, 0, 0, UseW, UseH)
       CALL AdjustWindowRectEx(rc, %dwStyle, %FALSE, %dwExStyle)  ' Adjust Window To True Requested Size

       hWnd = CreateWindowEx(%dwExStyle, szClassName, szClassName, _
                             %dwStyle, _
                             UseX, UseY, _
                             rc.nRight - rc.nLeft, _  ' Calculate Window Width
                             rc.nBottom - rc.nTop, _  ' Calculate Window Height
                             0, 0, zInstance(), BYVAL %NULL)
       IF hWnd THEN
          hCtrl = CreateWindowEx(0, "ListBox", BYVAL %NULL, _
                                 %WS_CHILD OR %WS_VISIBLE OR %WS_VSCROLL OR %WS_HSCROLL OR %LBS_MULTIPLESEL OR _
                                 %LBS_HASSTRINGS OR %LBS_NOINTEGRALHEIGHT OR %LBS_EXTENDEDSEL OR %LBS_DISABLENOSCROLL, _
                                 0, 0, UseW, UseH, _
                                 hWnd, %ID_LISTBOX, zInstance(), BYVAL %NULL)
          CALL SendMessage(hCtrl, %WM_SETFONT, GetStockObject(%ANSI_FIXED_FONT), 0)
          CALL AddString(hCtrl, zPtr) '// VARPTR(zMessage))
          IF gbScrollBar THEN
             CALL SendMessage(hCtrl, %LB_SETHORIZONTALEXTENT, %HORIZONTAL_EXTENT, 0)
             CALL ShowScrollBar(hCtrl, %SB_HORZ, %TRUE)
          ELSE
             CALL ShowScrollBar(hCtrl, %SB_HORZ, %FALSE)
          END IF

          IF gbUseTopMost THEN
             CALL SetWindowPos(hWnd, %HWND_TOPMOST, 0, 0, 0, 0, %SWP_NOSIZE OR %SWP_NOMOVE OR %SWP_SHOWWINDOW)
          ELSE
             CALL ShowWindow(hWnd, %SW_SHOW)
          END IF
          CALL UpdateWindow(hWnd)

          WHILE GetMessage(Msg, %NULL, 0, 0)
             '// Easier to detect the right mouse button click on the listBox from the message pump
             IF Msg.hWnd = hCtrl AND Msg.Message = %WM_RBUTTONDOWN THEN
                CALL ToolProc(hWnd, %WM_RBUTTONDOWN, 0, 0)
             ELSE
                IF IsDialogMessage(hWnd, Msg) = %FALSE THEN
                   CALL TranslateMessage(Msg)
                   CALL DispatchMessage(Msg)
                END IF
             END IF
          WEND

          FUNCTION = msg.wParam

       END IF

    END IF

END FUNCTION
